/*
 * kapp4view.h
 *
 * Copyright (C) 2007 Your Name <andrei@linux-df2s>
 */
#ifndef KAPP4VIEW_H
#define KAPP4VIEW_H

#include <QtGui/QWidget>

#include "ui_kapp4view_base.h"

class QPainter;
class KUrl;

/**
 * This is the main view class for KApp4.  Most of the non-menu,
 * non-toolbar, and non-statusbar (e.g., non frame) GUI code should go
 * here.
 *
 * @short Main view
 * @author Your Name <andrei@linux-df2s>
 * @version 0.1
 */

class KApp4View : public QWidget, public Ui::kapp4view_base
{
    Q_OBJECT
public:
    /**
     * Default constructor
     */
    KApp4View(QWidget *parent);

    /**
     * Destructor
     */
    virtual ~KApp4View();

private:
    Ui::kapp4view_base ui_kapp4view_base;

signals:
    /**
     * Use this signal to change the content of the statusbar
     */
    void signalChangeStatusbar(const QString& text);

    /**
     * Use this signal to change the content of the caption
     */
    void signalChangeCaption(const QString& text);

private slots:
    void switchColors();
    void settingsChanged();
};

#endif // KApp4VIEW_H
